<?php

// *******************************************************************
// Title          Module to report new messages for
//                udde Instant Messages (uddeIM)
// Description    Instant Messages System for Mambo 4.5.X
// Requires       udde Instant Messanges component 0.7 beta
// Author         Benjamin Zweifel, Stephan Slabihoud
// Version        0.7b
// Contact        ssl@gmx.de
// Copyright       by Benjamin Zweifel, Stephan Slabihoud
// License        This is free software and you may redistribute it under the GPL.
//                uddeim comes with absolutely no warranty. For details, see the license at
//                http://www.gnu.org/licenses/gpl.txt
//                YOU ARE NOT REQUIRED TO KEEP COPYRIGHT NOTICES IN
//                THE HTML OUTPUT OF THIS SCRIPT. YOU ARE NOT ALLOWED
//                TO REMOVE COPYRIGHT NOTICES FROM THE SOURCE CODE.
// *******************************************************************

defined( '_VALID_MOS' ) or die( 'Direct Access to this location is not allowed.' );

// Get right language file or use english
$pathtome="components/com_uddeim";
$adminpath="administrator/components/com_uddeim";

if(!defined('_UDDEIM_INBOX')) {
	if (file_exists($adminpath.'/language/'.$mosConfig_lang.'.php')) {
		include($adminpath.'/language/'.$mosConfig_lang.'.php');
	} elseif (file_exists($adminpath.'/language/english.php')) {
		include($adminpath.'/language/english.php');
	} 
}
	
// get the parameers
$par_showmsg = $params->get( 'showmsg' );
$par_maxchars = $params->get( 'maxchars' );
$par_manylines = $params->get( 'manylines' );

if(!$par_maxchars) {
	$par_maxchars=24;
}

if($par_manylines<0) {
	$par_manylines=0;
}

// get the configuration file
require($mosConfig_absolute_path."/administrator/components/com_uddeim/uddeim_config.php");

// parameters
$nomessages=_UDDEMODULE_NONEW;
$privatemessages=_UDDEMODULE_PRIVATEMESSAGES;

// Get the item id of the uddeIM component
	$sql="SELECT id FROM #__menu WHERE link LIKE '%com_uddeim%' AND published>=0 LIMIT 1";
	$database->setQuery($sql);
	$found=$database->loadResult();

$item_id=$found;
$headline="<a href=index.php?option=com_uddeim&task=inbox&Itemid=".$item_id.">".$privatemessages."</a>";

if($config_realnames) {
	$sql="SELECT a.*, b.name AS displayname FROM #__uddeim AS a, #__users AS b WHERE a.toread<1 AND a.toid=".$my->id." AND a.fromid=b.id ORDER BY a.datum";
} else {
	$sql="SELECT a.*, b.username AS displayname FROM #__uddeim AS a, #__users AS b WHERE a.toread<1 AND a.toid=".$my->id." AND a.fromid=b.id ORDER BY a.datum";
}
$database->setQuery($sql);
$allmessages=$database->loadObjectList();
$totalmessages=count($allmessages);

if(file_exists('components/com_uddeim/templates/'.$config_templatedir.'/css/uddemodule.css')) {
		echo '<link rel="stylesheet" href="components/com_uddeim/templates/'.$config_templatedir.'/css/uddemodule.css" type="text/css" />';
		echo "\n";
} elseif(file_exists('components/com_uddeim/templates/default/css/uddemodule.css')) {
		echo '<link rel="stylesheet" href="components/com_uddeim/templates/default/css/uddemodule.css" type="text/css" />';
		echo "\n";
}

$uddeicons_modulenewmess='components/com_uddeim/templates/'.$config_templatedir.'/images/env_ani.gif';
$uddeicons_modulenonewmess='components/com_uddeim/templates/'.$config_templatedir.'/images/env.gif';

if (($totalmessages)>0) {
	echo "<div id='uddeim-modulenew'>";
	if($par_showmsg>0) {
		echo "<p class='uddeim-module-head'>".$headline;
		echo " ";
		if (file_exists($uddeicons_modulenewmess)) {
			echo "<a href=index.php?option=com_uddeim&task=inbox&Itemid=".$item_id."><img border='0' src='".$uddeicons_modulenewmess."'></a>";
		}
		echo "</p>";
		$zaehler=1;
		foreach($allmessages as $themessage) {
			if($zaehler>$par_manylines && $par_manylines!=0) {	
				// don't do anything
			} else {
				if($themessage->systemmessage) {
					$whofrom=$themessage->systemmessage;
				} else {
					$whofrom=$themessage->displayname;
				}
				if (function_exists('bcdiv')) {
					$halfchars=bcdiv($par_maxchars,2,0);
				} elseif (function_exists('floor')) {
					$halfchars=floor($par_maxchars/2);
				} else {
					$halfchars=($par_maxchars/2);
				}
				if(strlen($whofrom)>=($halfchars-1)) {
					$whofrom=substr($whofrom, 0, ($halfchars-1));
					$whofrom=$whofrom.".";
				}
				echo "<p class='uddeim-module-row'>";
				echo $whofrom;
				$userlen=strlen($themessage->displayname);
				$maxlen=$par_maxchars-$userlen;
				
				
				
  if (file_exists( $mosConfig_absolute_path."/administrator/components/com_uddeim/uddeim_crypt.php" )) {
    include( $mosConfig_absolute_path."/administrator/components/com_uddeim/uddeim_crypt.php" );
  } else { // if not found, use standard
    $config_cryptkey = 'uddeIMcryptkey';
  }
  if ($themessage->cryptmode==1) {
    $cm = Decrypt($themessage->message,$config_cryptkey,CRYPT_MODE_BASE64);
  }
				
				
				$displaymessage=stripslashes($cm);
				if($themessage->systemmessage || $config_allowbb) {					
					require_once ('components/com_uddeim/bbparser.php');
					$displaymessage=bbcode_strip($displaymessage);
				}
				$displaymessage=htmlspecialchars($displaymessage, ENT_QUOTES, $config_charset);
				$displaymessage=str_replace("&amp;#", "&#", $displaymessage); 
				if($maxlen<5) { $maxlen=5; }
				echo " ";
				echo "<a href=index.php?option=com_uddeim&Itemid=".$item_id."&task=show&messageid=".$themessage->id.">".teaser_head($displaymessage, $maxlen)."</a>";
				echo "</p>";
			}
		$zaehler++;
		}
	} else {
		echo "<p class='uddeim-module-head'>".$headline;
		echo " ";
		if (file_exists($uddeicons_modulenewmess)) {
			echo "<a href=index.php?option=com_uddeim&task=inbox&Itemid=".$item_id."<img border='0' src='".$uddeicons_modulenewmess."'></a>";
		}
		echo "</p>";
		echo "<p class='uddeim-module-body'><a href=index.php?option=com_uddeim&task=inbox&Itemid=".$item_id.">"._UDDEMODULE_NEWMESSAGES." ".$totalmessages."</a></p>";
	}
} else {
	echo "<div id='uddeim-module'>";
	echo "<p class='uddeim-module-head'>".$headline;
	echo " ";
	if (file_exists($uddeicons_modulenonewmess)) {
		echo "<a href=index.php?option=com_uddeim&task=inbox&Itemid=".$item_id."><img border='0' src='".$uddeicons_modulenonewmess."'></a>";
	}
	echo "</p>";
    echo "<p class='uddeim-module-body'>".$nomessages."</p>";
}

	echo "</div>";	  
		  
		  
function teaser_head($ofwhat, $howlong) {
	$msgparts=explode("__________", $ofwhat, 2);

	$words=explode(" ", $msgparts[0]);
	$howmanywords=count($words);

	$x=0;
	if (!$howlong) { $howlong=33; }
	$trailstring="";
	if (strlen($msgparts[0])>$howlong) {
		$howlong=$howlong-3;
		$trailstring="...";
	}
	$construct="";
		// while ((strlen($construct)+strlen($words[$x]))<=$howlong):
		//		$construct.=" ".$words[$x];
		// $x++;
		// endwhile;
		if(strlen($words[0])>$howlong) {
			$construct=substr($words[0], 0, ($howlong-3));
		} else {		
			for($x=0; $x < $howmanywords; $x++) {
				$posslen=strlen($construct)+strlen($words[$x]);
				if($posslen<=$howlong) {
					$construct.=" ".$words[$x];
				} else {
					break;
				}
			}
		}
	$construct.=$trailstring;
	$construct=ltrim($construct);
	if(empty($construct)) {
		$construct="...";
	}	
	
	return $construct;
}

?>